package gve.calc.formula;

import java.util.Vector;

/** @version 4 nov 1999
 * @author Geert Vernaeve
 * This class is used to store locally defined variable names and values
 * when evaluating a formula, e.g. when plotting f(x) to define the
 * value of x.
 * Since 17-Jan-2000, it is also used to evaluate functions.
 */
public interface Evaluator
{
	public void defineVariable(String name,Part value);

	/** Note: it's possible that you get the same variable name twice. */
	public java.util.Enumeration variables();

	public void undefVariable(String name);

	public Object clone();

	/* Returns the value of a previously defined identifier (using
	 * <TT>defineVariable()</TT>). */
	public Part getValue(String identifier);

	/** Change the value of an existing variable. If the variable doesn't
	 * exist, this call is equivalent to defineVariable(). */
	public void setValue(String name,Part value);

	public void dump();

	/** Evaluate a function with given arguments.
	 * Returns null if no such function exists. */
	public Part call(String funcname,Part args);

	public void setFunction(String funcname,Function f);

	public boolean isFunction(String funcname);
}

