package gve.calc.formula;

import java.awt.*;

/** Part that contains a string inside, e.g. a Boolean, which
 * contains "true" or "false". If the user attempts to modify the
 * string, the Part changes itself into an identifier.
 * Conversely, an identifier containing the string "true" can change
 * into a boolean upon evaluation by an Evaluator. */
public abstract class StaticString extends Part {
	/* The string representation of the Part. */
	public abstract String getName();

	public void write(java.io.Writer w) throws java.io.IOException {
		w.write(getName());
		w.write('\n');
	}

	public Component createView(FormulaView view) {
		return new StaticStringView(this,view);
	}
}
