/** Copyright (C) 2000, 2001, Geert Vernaeve. All Rights Reserved. */
// This class is reserved because GveCalc used this class to represent
// proof lines in ProofViews. When this class disappears, we cannot
// read old GveCalc proofs anymore.
package gve.calc.formula;

import java.awt.*;

/** Cursor cannot be at this part; it is just a visual ornament, e.g. the
 * line numbers of a proof. */
public class Uneditable extends Part {
	Part child;

	public Uneditable(Part ch) { child = ch; ch.setParent(this); }

	public Object clone() { return new Uneditable((Part)child.clone()); }

	public Part evaluate(Evaluator ev) { return child.evaluate(ev); }

	public boolean same(Object o) {
		return true;	// quick&dirty
	}

	public Part getChild() { return child; }

	public void write(java.io.Writer w) throws java.io.IOException {
		super.write(w);
		child.write(w);
	}
	public static Part read(java.io.BufferedReader r) throws java.io.IOException,
			ClassNotFoundException,NoSuchMethodException,
			java.lang.reflect.InvocationTargetException,IllegalAccessException {
		return new Uneditable(Part.read(r));
	}

	public Component createView(FormulaView view) {
		return new UneditableView(this,view);
	}
}
